#include "Arduino.h"
#include "Stepmot.h"

Stepmot::Stepmot(int pin1, int pin2, int pin3, int pin4, int time)
{
  pinMode(pin1, OUTPUT);
  pinMode(pin2, OUTPUT);
  pinMode(pin3, OUTPUT);
  pinMode(pin4, OUTPUT);
  _pin1=pin1;
  _pin2=pin2;
  _pin3=pin3;
  _pin4=pin4;
  _time=time;
}

void Stepmot::Step1()
{
  digitalWrite (_pin1, HIGH);
  digitalWrite (_pin2, HIGH);
  digitalWrite (_pin3, LOW);
  digitalWrite (_pin4, LOW);
}

void Stepmot::Step2()
{
  digitalWrite (_pin1, LOW);
  digitalWrite (_pin2, HIGH);
  digitalWrite (_pin3, HIGH);
  digitalWrite (_pin4, LOW);
}

void Stepmot::Step3()
{
  digitalWrite (_pin1, LOW);
  digitalWrite (_pin2, LOW);
  digitalWrite (_pin3, HIGH);
  digitalWrite (_pin4, HIGH);
}

void Stepmot::Step4()
{
  digitalWrite (_pin1, HIGH);
  digitalWrite (_pin2, LOW);
  digitalWrite (_pin3, LOW);
  digitalWrite (_pin4, HIGH);
}

void Stepmot::Stop()
{
  digitalWrite (_pin1, LOW);
  digitalWrite (_pin2, LOW);
  digitalWrite (_pin3, LOW);
  digitalWrite (_pin4, LOW);
}

void Stepmot::Plateau(int cdeP)
{
  _cdeP=cdeP;
  int x=0;
  int numstep=1;
  if(_cdeP>0)
  {
    for(x=0; x<=_cdeP; x++)
    { 
      switch (numstep)
      {
        case 1:
          Step1();
          delay (_time);
          numstep++;
         break;
        case 2:  
          Step2();
          delay (_time);
          numstep++;
         break;
        case 3: 
          Step3();
          delay (_time);
          numstep++;
         break;
        case 4:  
          Step4();
          delay (_time);
          numstep=1;
         break;
      }
    }
  }
  else if(_cdeP<0)
  {   
    for(x=0; x>=_cdeP; x--)
    { 
      switch (numstep)
      {
        case 1:
          Step4();
          delay (_time);
          numstep++;
         break;
        case 2:  
          Step3();
          delay (_time);
          numstep++;
         break;
        case 3: 
          Step2();
          delay (_time);
          numstep++;
         break;
        case 4:  
          Step1();
          delay (_time);
          numstep=1;
         break;
      }
    }
  }
  else if (_cdeP==0)
  {
    Stop();
  }
  Stop();  
}

void Stepmot::Chariot(int cdeC, int sensC)
{
    _cdeC=cdeC;
    _sensC=sensC;
    if (_cdeC!=0)
    {
      if (_sensC==1)
      {
        
      }
      else if (_sensC==0)
      {
        
      }
    }
}
    
